/**
 * @file globalSettings.h
 *
 * @ingroup iopccommon
 *
 * @author Petr Cermak
 */

#ifndef GLOBALSETTINGS_H_
#define GLOBALSETTINGS_H_

#include "metadataHolder.h"

namespace iopc {

/**
 * @brief Global settings for the library and application.
 *
 * This class is not thread safe. Settings should be set as using @a MetadataInitializer
 */
class DLL_EXTERNAL GlobalSettings : public MetadataHolder {
};

/**
 * @brief A single global settings object instance.
 *
 * Shouldn't be used in static blocks.
 */
extern GlobalSettings globalSettings;

}

#endif /*GLOBALSETTINGS_H_*/
