/**
 * @file iopcCommon.cpp
 *
 * @author Petr Cermak
 *
 * @ingroup iopccommon
 */

#include "iopcCommon.h"
#include "trace.h"
#include <string>

using namespace std;
namespace iopc {

void IopcCommon::init(int traceMaskTTY, int traceMask, const string& logFileName)
{

	LogWriter::initInstance();
	LogWriter::getInstance().traceMask = traceMask;
	LogWriter::getInstance().traceMaskTTY = traceMaskTTY;
	LogWriter::logOpen(logFileName);

}


void IopcCommon::shutdown()
{
	LogWriter::logClose();
	LogWriter::terminateInstance();
}

/*bool IopcCommon::isInitialized(bool initialized = false)
{
	static bool isInit = false;

	if (initialized == true) {
		isInit = true;
	}

	return isInit;
}*/


}
