/**
 * @file oracle10gDriver.h
 * 
 * @author Petr Cermak
 */

#ifndef ORACLE10GDRIVER_H_
#define ORACLE10GDRIVER_H_

#include "iopcdb/driver.h"
#include "iopcdb/databaseImpl.h"
#include "oracle10gSqlStatementsFeature.h"
//#include "oracle10gObjectMappingFeature.h"
#include "oracle10gTypeMappingFeature.h"

#include <string>

namespace iopc {
	
class Oracle10gDriver : public Driver {
	private:
//		static bool initialized;
		Oracle10gSqlStatementsFeature sqlStatementsFeature;
		Oracle10gTypeMappingFeature typeMappingFeature;
//		Oracle10gObjectMappingFeature objectMappingFeature;
	public:
		virtual DatabaseImpl* getDatabaseImpl(const std::string& dbName);
		virtual void returnDatabaseImpl(DatabaseImpl* dbImpl);
		
		Oracle10gDriver(const std::string& driverName);
		
	protected:
		virtual void doInit();
		virtual void doShutdown() {};
};

}

#endif /*ORACLE10GDRIVER_H_*/
