#include "iopc.h"
#include "iopcdb/driverManager.h"
#include "iopcmeta/iopcMeta.h"
#include "iopccommon/metadataHolder.h"
#include "types/dbTypeManager.h"
#include "iopccommon/globalSettings.h"
#include "oidObject.h"
#include "dbPtr.h"
#include "iopcdb/iopcDb.h"

namespace iopc {

void Iopc::init(MetadataInitializer* initializer, int traceMaskTTY, int traceMask, const std::string& logFileName)
{
	if (initializer != NULL) {
		IopcMeta::init(initializer, traceMaskTTY, traceMask, logFileName);
	} else {
		IopcMeta::init(traceMaskTTY, traceMask, logFileName);
	}

	MetadataHolder& defaults = MetadataHolder::getDefaultsMeta();
	if (!defaults.hasMeta("db.mapping.type")) {
		defaults["db.mapping.type"].setStringValue("vertical");
	}
	//defaults["db.mapping.oidmanaged"] = true;
	//globalSettings["db.initSqlForDrivers"] = "IopcOracle8i";
	//globalSettings["db.useSerialId"] = true;

	// Moved to iopcDb
	/*TypeDesc<EString>::getType()["db.type.length"].setIntValue(50);
	TypeDesc<EWString>::getType()["db.type.length"].setIntValue(50);*/


	TypeDesc<DbPtrBase>::getType()["iopc.enhancedType.innerType"].setPointerValue((void*)&EnhancedTypeBase::getInnerTypeFor(TypeDesc<OidType>::getType()));

	if (initializer != NULL) {
		IopcDb::init(initializer, traceMaskTTY, traceMask, logFileName, false);
	} else {
		IopcDb::init(traceMaskTTY, traceMask, logFileName, false);
	}
	//DriverManager::getInstance().initDrivers();
	DbTypeManager::init();
}

void Iopc::init(int traceMaskTTY, int traceMask, const std::string& logFileName)
{
	init(NULL, traceMaskTTY, traceMask, logFileName);
}

void Iopc::shutdown()
{
	//DriverManager::getInstance().shutdownDrivers();
	IopcDb::shutdown();
	//IopcMeta::shutdown();
}




}
