/**
 * @file enhancedTemplatesInst.h
 *
 * @ingroup iopcmeta
 *
 * @author Petr Cermak
 */

#include "enhancedNumber.h"
#include "enhancedString.h"

namespace iopc {

template<> std::string EStr<wchar_t>::toString() const
{
	if (isNull()) {
		return "null";
	}
	else {
		return Object::toString();
	}
}

template<> std::string EStr<char>::toString() const
{
	if (isNull()) {
		return "null";
	}
	else {
		return value;
	}
}


TypeDesc<EInt> TypeDesc<EInt>::instance;
TypeDesc<EUInt> TypeDesc<EUInt>::instance;
TypeDesc<EChar> TypeDesc<EChar>::instance;
TypeDesc<EUChar> TypeDesc<EUChar>::instance;
TypeDesc<ESChar> TypeDesc<ESChar>::instance;
TypeDesc<EShort> TypeDesc<EShort>::instance;
TypeDesc<EUShort> TypeDesc<EUShort>::instance;
TypeDesc<ELong> TypeDesc<ELong>::instance;
TypeDesc<EULong> TypeDesc<EULong>::instance;
TypeDesc<EFloat> TypeDesc<EFloat>::instance;
TypeDesc<EDouble> TypeDesc<EDouble>::instance;
TypeDesc<ELDouble> TypeDesc<ELDouble>::instance;
TypeDesc<EWCharT> TypeDesc<EWCharT>::instance;
TypeDesc<EBool> TypeDesc<EBool>::instance;
TypeDesc<EString> TypeDesc<EString>::instance;
TypeDesc<EWString> TypeDesc<EWString>::instance;


template class ENumber<int>;
template class ENumber<unsigned int>;
template class ENumber<char>;
template class ENumber<unsigned char>;
template class ENumber<signed char>;
template class ENumber<short>;
template class ENumber<unsigned short>;
template class ENumber<long>;
template class ENumber<unsigned long>;
template class ENumber<float>;
template class ENumber<double>;
template class ENumber<long double>;
template class ENumber<wchar_t>;
template class ENumber<bool>;

template class TypeDesc<EInt>;
template class TypeDesc<EUInt>;
template class TypeDesc<EChar>;
template class TypeDesc<EUChar>;
template class TypeDesc<ESChar>;
template class TypeDesc<EShort>;
template class TypeDesc<EUShort>;
template class TypeDesc<ELong>;
template class TypeDesc<EULong>;
template class TypeDesc<EFloat>;
template class TypeDesc<EDouble>;
template class TypeDesc<ELDouble>;
template class TypeDesc<EWCharT>;
template class TypeDesc<EBool>;


template class TypeDesc<EString>;
template class TypeDesc<EWString>;

/*template class EStr<char>;
template class EStr<wchar_t>;

template class TypeDesc<EInt>;
*/
}
