#include "tests/enhancedTypeTest.h"
#include "iopcmeta/enhancedNumber.h"
#include "iopcmeta/enhancedString.h"
#include <string>

using namespace iopc;
using namespace std;

EnhancedTypeTest::EnhancedTypeTest(const std::string& testName)
 : TestCase(testName)
{
}

EnhancedTypeTest::~EnhancedTypeTest()
{
}


bool EnhancedTypeTest::doTest()
{
	bool ret = true;
	EInt a = 8;
	a = 4;
	a = a + 2;
	int b = 2 + a;
	EFloat d = 2.5;
	d = (d + 2.5 + a) / 2;
	EDouble c = (a + 2)*(a + 3);
	--d;
	d--;
	d++;
	d+=a;
	d-=4;
	if (a >= d) {
		ret = false;
	}
	if (a != 6) {
		ret = false;
	}
	if (b != 8) {
		ret = false;
	}
	if (d != 6.5) {
		ret = false;
	} 
	if (c != 72.0) {
		ret = false;
	}
	
	if (!a.isDirty() || !d.isDirty() || c.isDirty()) {
		ret = false;
	}
	
	logMsg("Result -A: ", -a);
	logMsg("Result B: ", b);
	logMsg("Result C: ", c);
	logMsg("Result D: ", d);
	
	// String
	EString str = "aaa";
	
	std::string str2 = str;	
	
	str = "bb";
	
	if (!str.isDirty()) {
		ret = false;
	}
	logMsg("aa" + str);
	logMsg(str + str);
	logMsg(str2 + str);
	logMsg(str + str2);
	logMsg(str + "bb");
	
	return ret;
} 

static EnhancedTypeTest EnhancedTypeTestInstance("EnhancedType test");
